
#version 120
// neccesary for attribute int
#extension GL_EXT_gpu_shader4 : enable

uniform sampler2D textureImage;
uniform int fogMode;
uniform int dissolveMode;
uniform float clipThreshold;

uniform vec2 ensembleParamA;
uniform float ensembleParamB
;uniform vec2 ensembleParamC;

uniform float projInv11;
uniform float projInv15;

varying vec3 position;

//##FUNC_SMOOTHCLIPPING##

//##FUNC_ENSEMBLE_DITHERING##

//##FUNC_FOG_EFFECT##

void main (void)
{
    vec4 texColor = texture2D(textureImage, gl_TexCoord[0].st);
    if (texColor[3] < clipThreshold) discard;

    texColor[0] += 0.0001;
    texColor[1] += 0.0001;
    texColor[2] += 0.0001;
    
    gl_FragColor = texColor * gl_Color;// * diffuseAndAmbient;
    float alpha = gl_FragColor[3];

    //##APPLY_SMOOTHCLIPPING##

    //##APPLY_ENSEMBLE_DITHERING##
    
    //##APPLY_FOG_EFFECT##

    gl_FragColor[3] = alpha;
}
